/*
 * Copyright © 2009-2020 Frictional Games
 *
 * This file is part of Amnesia: The Dark Descent.
 *
 * Amnesia: The Dark Descent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * Amnesia: The Dark Descent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Amnesia: The Dark Descent.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef EDIT_MODE_HANDLER_H
#define EDIT_MODE_HANDLER_H

//----------------------------------------------------------------

#include "../Common/EdModule.h"
#include "../Common/EdEditMode.h"

//----------------------------------------------------------------

class iEdEditMode;

//----------------------------------------------------------------

class cEdEditModeHandler : public iEdModule
{
public:
	cEdEditModeHandler(iEditor*);
	~cEdEditModeHandler();

	void AddMode(iEdEditMode*);

	iEdEditMode* GetActiveMode();
	bool SetActiveMode(iEdEditMode*);

	iEdEditMode* GetMode(const tWString&);

	const tEditModeList& GetModes() { return mlstModes; }

protected:
	void OnInit();
	void OnCreateLayout();
	void OnUpdate();

	void OnDraw(const cModuleDrawData&);

	void OnWorldLoad();
	void OnWorldSave();

	void OnWorldAddRemObject();
	void OnWorldObjModify();
	void OnWorldSelectChange();

	void OnReset();

	void OnViewportMouseMove();
	void OnViewportMouseDown(const cViewportClick&);
	void OnViewportMouseUp(const cViewportClick&);

	void BroadcastMsgToModes(eEdModuleMsg, void*);

	//////////////////////////////////////////////////////
	// Data
	iEdEditMode*	mpActiveMode;
	tEditModeList	mlstModes;
};

//----------------------------------------------------------------

#endif // EDIT_MODE_HANDLER_H
